import subscribe from 'redux-heat'
import * as most from 'most'

// Define a selector to define what data to check for changes
const getUserId = state => state.userId

// Describe the effect based on state changes
const fetchUserHeat = state$ =>
  state$
    .map(getUserId)
    .unique()
    .flatMap(userId =>
      most
        .fromPromise(fetch(`/user/${userId}`))
        .map(user => ({ type: 'SET_USER_DETAILS', payload: user }))
        .recoverWith(error => most.of({ type: 'FETCH_USER_FAILED', payload: e }))
    )

// Then subscribe the effect to the Redux store
subscribe(reduxStore, fetchUserHeat)
